Subject: bug#486: pgg-gpg.el - pgg-gpg-process-region timing problem

From: "ken manheimer" <[email-masked]>
Date: Thu, 26 Jun 2008 12:16:17 -0400

i am not sure how to proceed with this problem.  as demonstrated by
the pggprob.el script, i consistently get encryption and decryption
problems without the contrived delay in my pgg-gpg-process-region
patch.  (the problem does not happen if i just do a regular
pgg-decrypt - i think the crucial thing is that a symmetric passphrase
is being passed into pgg-gpg-process-region.)

i have tried everything i could think of to exclude local quirks from
the problem, including starting emacs with '--no-site-file -q' and
eliminating everything from my ~/.gnupg/gpg.conf file.  i have
reproduced the problem (and workaround) consistently in kubuntu 8.04
emacs-snapshot package and a recent CVS HEAD checkout.  in fact, i
have incidentally reinstalled my kubuntu 8.04 OS recently, on both my
main 2.0 Ghz T43 thinkpad and on a 750 Mhz a20p thinkpad.  the problem
continues consistently on the t43 but does *not* occur on the a20p,
which is not contrary to the sensitivities of a timing problem.

i have also tried thien-thi nguyen's alternative approaches, but
neither worked for me, hanging in different places.

i am pretty sure this is a real problem, and something that warrants
attention.  i realize that the difficulty in repeating the problem
elsewhere increases the challenge in addressing it, and am open to
cooperating with people to try things, if that would help.  the
consistent effectiveness of my workaround should help provide clues
about the nature of the problem, at least.

any suggestions?
--
ken
http://myriadicity.net

On Sun, Jun 22, 2008 at 1:37 PM, ken manheimer <[email-masked]> wrote:
> allout encryption, which depends on pgg.el &c, has been failing due to
> a weird timing problem i've narrowed down to the
> pgg-gpg-process-region function.  this is in emacs 23.0.60 built from
> a CVS HEAD checkout of an hour or so ago, and some earlier 23.0.60
> versions.  i've reproduced the problem using emacs -q and regularly
> launched emacs, etc.
>
> the problem is that pgg-gpg-process-region often returns a nil status
> despite successful decryption, unless a delay (eg, (sleep-for .3) is
> inserted between process start and later interaction with the process.
>  with the delay, the status is something like 207 or 208, while
> without it the status is nil - yet, on examination the content is
> sucessfully decrypted.
>
> the size of the delay needs to be increased when the machine is
> heavily loaded, and can be reduced (on my thinkpad t43 2 GHz laptop,
> 3Gb ram, running kubuntu 8.0.4 +) to no lower than (sleep-for .2).
> rarely, the proper status is returned without the delay, depending on
> the machine load and other things i can't identify.  considering the
> real-time sensitivity of the problem, your mileage will almost
> certainly vary!
>
> i originally thought the problem might be in gpg, but now figure it
> resides either in the emacs process mechanism, pgg's use of that, or
> somewhere in the combination of emacs and pgg.
>
> i've created a simple .el script, pggprob.el, with minimal code and
> data to produce the problem, and a patch, pggprob-patch.txt, with a
> single-line modification to pgg-gpg-process-region to work around the
> problem.  both are attached.  since the workaround is merely a timing
> delay, it's clearly not a fix!  i'm hoping this is enough to enable
> others to reproduce the problem, and investigate...
> --
> ken
> http://myriadicity.net
>
> If Emacs crashed, and you have the Emacs process in the gdb debugger,
> please include the output from the following gdb commands:
>    `bt full' and `xbacktrace'.
> If you would like to further debug the crash, please read the file
> /home/klm/src/emacs-HEAD/etc/DEBUG for instructions.
>
> In GNU Emacs 23.0.60.1 (i686-pc-linux-gnu, GTK+ Version 2.12.9)
>  of 2008-06-22 on twist
> Windowing system distributor `The X.Org Foundation', version 11.0.10400090
> Important settings:
>  value of $LC_ALL: nil
>  value of $LC_COLLATE: nil
>  value of $LC_CTYPE: nil
>  value of $LC_MESSAGES: nil
>  value of $LC_MONETARY: nil
>  value of $LC_NUMERIC: nil
>  value of $LC_TIME: nil
>  value of $LANG: en_US.UTF-8
>  value of $XMODIFIERS: nil
>  locale-coding-system: utf-8-unix
>  default-enable-multibyte-characters: t
>
> Major mode: Emacs-Lisp
>
> Minor modes in effect:
>  tooltip-mode: t
>  tool-bar-mode: t
>  mouse-wheel-mode: t
>  menu-bar-mode: t
>  file-name-shadow-mode: t
>  global-font-lock-mode: t
>  font-lock-mode: t
>  blink-cursor-mode: t
>  global-auto-composition-mode: t
>  auto-composition-mode: t
>  auto-encryption-mode: t
>  auto-compression-mode: t
>  line-number-mode: t
>  transient-mark-mode: t
>
> Recent input:
> C-x C-f <M-backspace> <M-backspace> <M-backspace> l
> i b / e m a <tab> a l l <tab> s c r <tab> p g g p <tab>
> <return> M-x e v a l - c u r <tab> <return> M-. C-g
> M-> C-x C-e M-x e m a c s <M-backspace> r e p o r t
> - e m <tab> <return>
>
> Recent messages:
> For information about GNU Emacs and the GNU system, type C-h C-a.
> Source file `/home/klm/src/emacs-HEAD/lisp/pgg-gpg.el' newer than
> byte-compiled file
> Quit
> Mark set
> nil
>

-- 
ken
http://myriadicity.net
--- pgg-gpg.el.~1.27.~	2008-05-06 03:57:46.000000000 -0400
+++ pgg-gpg.el	2008-06-22 13:24:14.000000000 -0400
@@ -86,6 +86,7 @@
 	    (setq process
 		  (apply #'start-process "*GnuPG*" errors-buffer
 			 program args)))
+          (sleep-for .3)                ; klm: timing delay
 	  (set-process-sentinel process #'ignore)
 	  (when passphrase
 	    (setq passphrase-with-newline (concat passphrase "\n"))